/* Keep this file language agnostic. Only preprocessor here. */

#ifndef __FIRMWARE_SYMBOLS_H_S__
#define __FIRMWARE_SYMBOLS_H_S__

// 4.21 CEX Symbols

#if defined(FIRMWARE_4_21_CEX)

#define TOC									0x346390

#define copy_from_user_symbol				0xf85c
#define copy_from_process_symbol			0xf724
#define page_allocate_symbol				0x5fa48
#define page_free_symbol					0x5f4ac
#define page_export_to_proc_symbol			0x5fbe4
#define page_unexport_from_proc_symbol		0x5F3A0

#define ppu_thread_join_symbol				0x13fc0
#define create_user_thread2_symbol			0x24e38
#define start_thread_symbol					0x23b04
#define run_thread_symbol					0x23334
#define register_thread_symbol				0x296a64
#define allocate_user_stack_symbol			0x29724c

#define prx_load_module_symbol				0x88168
#define prx_start_module_symbol				0x86e34
#define prx_stop_module_symbol				0x8820c
#define prx_unload_module_symbol			0x86b68
#define prx_get_module_info_symbol			0x865F0
#define prx_get_module_id_by_address_symbol 0x86500

#define extend_kstack_symbol				0x6f748

#define syscall_table_symbol				0x35BCA8

#define printf_symbol						0x29E77C

#endif

// 4.21 DEX Symbols

#if defined(FIRMWARE_4_21_DEX)

#define TOC									0x363E80

#define copy_from_user_symbol				0xfea4
#define copy_from_process_symbol			0xfd6c
#define page_allocate_symbol				0x63360
#define page_free_symbol					0x62dc4
#define page_export_to_proc_symbol			0x634fc
#define page_unexport_from_proc_symbol		0x62CB8

#define ppu_thread_join_symbol				0x1463c
#define create_user_thread2_symbol			0x26a30
#define start_thread_symbol					0x25568
#define run_thread_symbol					0x24d2c
#define register_thread_symbol				0x29d2c8
#define allocate_user_stack_symbol			0x29dab0

#define prx_load_module_symbol				0x8c7b4
#define prx_start_module_symbol				0x8b480
#define prx_stop_module_symbol				0x8c858
#define prx_unload_module_symbol			0x8b1b4
#define prx_get_module_info_symbol			0x8ABAC
#define prx_get_module_id_by_address_symbol 0x8AABC

#define extend_kstack_symbol				0x731e0

#define syscall_table_symbol				0x37A1B0

#define printf_symbol						0x2A6828

#endif

// 4.46 DEX Symbols

#if defined(FIRMWARE_4_46_DEX)

#define TOC									0x366BD0

#define alloc_symbol						0x66890
#define dealloc_symbol						0x66CCC
#define process_table_symbol				0x4B9400
#define copy_from_user_symbol				0x100C0
#define copy_to_user_symbol					0xFEA4
#define copy_from_process_symbol			0xFD6C
#define copy_to_process_symbol				0xFF5C
#define page_allocate_symbol				0x62400
#define page_free_symbol					0x61E64
#define page_export_to_proc_symbol			0x6259C
#define page_unexport_from_proc_symbol		0x61D58

#define ppu_thread_join_symbol				0x146B4
#define create_user_thread2_symbol			0x26AA8
#define start_thread_symbol					0x255E0
#define run_thread_symbol					0x24DA4 /* temp name */
#define register_thread_symbol				0x29E374
#define allocate_user_stack_symbol			0x29EB5C

#define prx_load_module_symbol				0x8B880
#define prx_start_module_symbol				0x8A54C
#define prx_stop_module_symbol				0x8B924
#define prx_unload_module_symbol			0x8A280
#define prx_get_module_info_symbol			0x89C78
#define prx_get_module_id_by_address_symbol		0x89B88

#define extend_kstack_symbol				0x7225C

#define syscall_table_symbol				0x37CFE8

#define printf_symbol						0x2A8A40

#endif

// 4.46 Cex Symbols

#if defined(FIRMWARE_4_46_CEX)									//search pattern

#define TOC									0x348DF0

#define copy_from_user_symbol				0xF85C					//2F BC 00 00 3C 60 80 01  7F E4 FB 78 7F C5 F3 78 <- first of 2 funcs
#define copy_from_process_symbol			0xF724					//7C 79 1B 78 7C DC 33 78  63 7B 00 0D 41 80 00 88
#define page_allocate_symbol				0x5EAE8					//7C 80 23 78 7C A9 2B 78  7C CB 33 78 7C E8 3B 78
#define page_free_symbol					0x5E54C					//E9 2B 00 00 7C 7F 1B 78  7C BE 2B 78 38 C1 00 78
#define page_export_to_proc_symbol			0x5EC84					//7F A0 48 00 3D 20 80 01  7C DF 33 78 2F 25 00 00
#define page_unexport_from_proc_symbol		0x5E440					//38 A1 00 70 38 C1 00 78  38 63 03 50 F8 01 00 90 <- 1 func up

#define ppu_thread_join_symbol				0x14038					//7C 7D 1B 78 64 00 DE AD  38 A1 00 70 60 00 BE EF
#define create_user_thread2_symbol			0x24EB0					//7D 39 4B 78 7C 77 1B 78  39 20 00 02 7C B5 2B 78
#define start_thread_symbol					0x23B7C					//38 80 00 10 7F A3 EB 78  38 A0 00 00 38 C0 FF FF
#define run_thread_symbol					0x233AC /* temp name */ //7C 64 1B 78 E8 63 00 48
#define register_thread_symbol				0x297B10				//41 82 00 70 54 BD 06 3E  2E 1D 00 00 41 92 00 C0
#define allocate_user_stack_symbol			0x2982F8				//E9 24 00 00 39 29 0F FF  79 3F 04 E4 2F BF 00 00

#define prx_load_module_symbol				0x87234					//38 80 00 00 2F 83 00 00  7C 60 1B 78 7F C3 F3 78
#define prx_start_module_symbol				0x85F00					//3B A0 00 00 63 FF 18 01  E8 1E 00 F8 7F A0 D0 00
#define prx_stop_module_symbol				0x872D8					//A0 1F 00 2A 54 00 07 FE  2F 80 00 00 41 9E 00 10
#define prx_unload_module_symbol			0x85C34					//3F E0 80 01 2F A4 00 00  63 FF 11 2E 41 9E 00 1C
#define prx_get_module_info_symbol			0x856BC					//7C 64 1B 78 3C 60 80 01  60 63 18 01 40 82 00 34 <- 1 func up
#define prx_get_module_id_by_address_symbol		0x855CC				//called by syscall__sys_prx_get_module_id_by_address (last branch)

#define extend_kstack_symbol				0x6E7C4					//E8 83 00 50 7B A7 00 20  38 A0 00 01 38 84 F0 00

#define syscall_table_symbol				0x35E860

#define printf_symbol						0x2A0800

#endif

// 4.50 CEX Symbols

#if defined(FIRMWARE_4_50_CEX)

#define TOC									0x34B160

#define copy_from_process_symbol            0x00F720
#define copy_from_user_symbol               0x00FA74
#define page_allocate_symbol                0x05EAE4
#define page_export_to_proc_symbol          0x05EC80
#define page_free_symbol                    0x004348
#define page_unexport_from_proc_symbol      0x05E43C

#define ppu_thread_join_symbol              0x014034
#define create_user_thread2_symbol          0x024EAC
#define start_thread_symbol                 0x023B78
#define run_thread_symbol                   0x0233A8 /* temp name */
#define register_thread_symbol              0x26FE18
#define allocate_user_stack_symbol          0x270600

#define prx_get_module_id_by_address_symbol 0x0855C8
#define prx_get_module_id_by_name_symbol    0x085618
#define prx_get_module_info_symbol          0x0856B8
#define prx_get_module_list_symbol          0x085738
#define prx_load_module_symbol              0x087230
#define prx_start_module_symbol             0x085EFC
#define prx_stop_module_symbol              0x0872D4
#define prx_unload_module_symbol            0x085C30

#define extend_kstack_symbol                0x06E7C0

#define syscall_table_symbol				0x35F0D0

#define printf_symbol						0x278B08

#endif


// 4.50 Dex Symbols

#if defined(FIRMWARE_4_50_DEX)

#define TOC									0x36EC40

#define copy_from_user_symbol				0xfea0
#define copy_from_process_symbol			0xfd68
#define page_allocate_symbol				0x624b4
#define page_free_symbol					0x61f18
#define page_export_to_proc_symbol			0x62650
#define page_unexport_from_proc_symbol		0x61E0C
#define ppu_thread_join_symbol				0x14768
#define create_user_thread2_symbol			0x26b5c
#define start_thread_symbol					0x25694
#define run_thread_symbol					0x24e58
#define register_thread_symbol				0x27673c
#define allocate_user_stack_symbol			0x276f24
#define prx_load_module_symbol				0x8b934
#define prx_start_module_symbol				0x8a600
#define prx_stop_module_symbol				0x8b9d8
#define prx_unload_module_symbol			0x8a334
#define prx_get_module_id_by_address_symbol 0x89C3C
#define prx_get_module_info_symbol			0x89D2C

#define extend_kstack_symbol				0x72310

#define syscall_table_symbol				0x383658

#define printf_symbol						0x280E08


#endif

// 4.53 Cex Symbols

#if defined(FIRMWARE_4_53_CEX)

#define TOC									0x34B2E0

#define copy_from_user_symbol				0xf85c
#define copy_from_process_symbol			0xf724
#define page_allocate_symbol				0x5eae8
#define page_free_symbol					0x5e54c
#define page_export_to_proc_symbol			0x5ec84
#define page_unexport_from_proc_symbol      0x5E440

#define ppu_thread_join_symbol				0x14038
#define create_user_thread2_symbol			0x24eb0
#define start_thread_symbol					0x23b7c
#define run_thread_symbol					0x233ac
#define register_thread_symbol				0x26fff0
#define allocate_user_stack_symbol			0x2707d8

#define prx_get_module_id_by_address_symbol 0x855CC
#define prx_get_module_info_symbol          0x856BC
#define prx_load_module_symbol				0x87234
#define prx_start_module_symbol				0x85f00
#define prx_stop_module_symbol				0x872d8
#define prx_unload_module_symbol			0x85c34

#define extend_kstack_symbol				0x6e7c4

#define syscall_table_symbol				0x35F300

#define printf_symbol						0x278CE0


#endif

// 4.53 Cex Symbols

#if defined(FIRMWARE_4_55_CEX)

#define TOC									0x34E620

#define copy_from_user_symbol				0xFA88
#define copy_from_process_symbol			0xF734
#define page_allocate_symbol				0x5FF24
#define page_free_symbol					0x5F988
#define page_export_to_proc_symbol			0x600C0
#define page_unexport_from_proc_symbol		0x5F87C

#define ppu_thread_join_symbol				0x14048
#define create_user_thread2_symbol			0x250F4
#define start_thread_symbol					0x23DC0
#define run_thread_symbol					0x235F0
#define register_thread_symbol				0x27183C
#define allocate_user_stack_symbol			0x272024

#define prx_load_module_symbol				0x88680
#define prx_start_module_symbol				0x8734C
#define prx_stop_module_symbol				0x88724
#define prx_unload_module_symbol			0x87080
#define prx_get_module_info_symbol			0x86B08
#define prx_get_module_id_by_address_symbol	0x86A18

#define extend_kstack_symbol				0x6FC00

#define syscall_table_symbol				0x362680

#define printf_symbol						0x27A530

// 4.60 Cex Symbols Ported by Joonie, big thanks to @aldostools,@Estwald,@Us$r,@Team Cobra, and many of you who I forgot to mention :)

#if defined(FIRMWARE_4_60)

#define TOC                                             0x34F950 //done

#define copy_from_user_symbol  v                        0xFA84  //done
#define copy_from_process_symbol                        0xF730  //done
#define page_allocate_symbol                            0x60308 //done
#define page_free_symbol                                0x5FD6C //done
#define page_export_to_proc_symbol                      0x604A4 //done
#define page_unexport_from_proc_symbol                  0x5FC60 //done //E8630030480110
#define ppu_thread_join_symbol                          0x13FD0  //done //F821FF617C0802A6 FB810080F80100B0
#define create_user_thread2_symbol                      0x2507C  //done //F821FEF1 7C0802A6FA8100B0 F801012080090028
#define start_thread_symbol                             0x23D48  //done //7D800026F821FF61 FB410070FB610078
#define run_thread_symbol                               0x23578  //done //7C641B78E8630048 48002EB0F821FF71
#define register_thread_symbol                          0x2705D0 //done  // +184C //7D800026 F821FF712C240000
#define allocate_user_stack_symbol                      0x270DB8 //done //F821FF61 7C0802A6FBA10088 F80100B0E8030030
#define prx_load_module_symbol                          0x88B78  //done //F821FF717C0802A6 FB8100707CBC2B78 38A00001FBA10078 FBC10080FBE10088
#define prx_start_module_symbol                         0x87844  //done //7D800026 F821FEF1FB2100D8 FB4100E07C7907B4 7C9A2378FB0100D0 FB8100F0
#define prx_stop_module_symbol                          0x88C1C  //done //F821FF61 7C0802A6FBA10088 FBC100907C7D1B78 7C9E2378FB810080 F80100B0
#define prx_unload_module_symbol                        0x87578  //done find "F821FF617C0802A6FB810080FBC100907C7C07B47C9E2378FBA10088"
#define prx_get_module_info_symbol			            0x87000
#define prx_get_module_id_by_address_symbol	            0x86F10
#define extend_kstack_symbol				            0x70018
#define syscall_table_symbol				            0x363A18 //done
#define printf_symbol					                0x279330 //done

#endif 

#endif /* FIRMWARE */

#endif /* __FIRMWARE_SYMBOLS_H_S__ */
